uniform float BAILOUT;
uniform int MAX_ITERS;
uniform float Z_LEVEL;
varying vec2 coords;
void main(void)
{
  vec4 c = vec4(coords, Z_LEVEL, 0.0);
  float r2 = dot(c,c);
  int iters = 0;
  vec4 z = c;
  while ( (iters < MAX_ITERS) &&
          (r2 < BAILOUT) )
  {
    vec4 z2 = z*z;
    z2.w = z2.x + z2.y;
    z.w = sqrt(z2.w);
    vec4 z4 = z2*z2;
    vec4 z6 = z4*z2;
    vec4 z8 = z4*z4;
    float a = 8.0*z.z*(z6.z-7.0*z4.z*z2.w+7.0*z2.z*z4.w-z6.w) / (z6.w*z.w);
    z = vec4(a*(z8.x-28.0*z6.x*z2.y+70.0*z4.x*z4.y-28.0*z2.x*z6.y+z8.y),
             8.0*a*z.x*z.y*(z6.x-7.0*z4.x*z2.y+7.0*z2.x*z4.y-z6.y),
             z8.z-28.0*z6.z*z2.w+70.0*z4.z*z4.w-28.0*z2.z*z6.w+z8.w,
             0.0) + c;
    r2 = dot(z,z);
    ++iters;
  }
  if ( r2 < BAILOUT )
  {
    gl_FragColor = vec4(1.0, 1.0, 1.0, 1.0);
  }
  else
  {
    discard;
  }
}
